Index: win32/BUILD.TXT
===================================================================
--- win32/BUILD.TXT	(revision d1d677615e12d759b6cdf7ce23a493bc055ef37f)
+++ win32/BUILD.TXT	(revision 99318adcb88fa3f1dd21882ec364e682fec96c5e)
@@ -5,8 +5,9 @@
    bzr branch http://jelmer.vernstok.nl/oss/bitlbee/bzr/win32 bitlbee-win32
 2. Download and install the required development files: 
-    from http://www.ethereal.com/distribution/win32/development/:
-    - libiconv
+    from ftp://ftp.gtk.org/pub/gtk/v2.8/win32/
     - glib
     - glib-dev
+	- libiconv
+	- gettext
     from http://ftp.mozilla.org/pub/mozilla.org/
     - nss
Index: win32/bitlbee.dsp
===================================================================
--- win32/bitlbee.dsp	(revision d1d677615e12d759b6cdf7ce23a493bc055ef37f)
+++ win32/bitlbee.dsp	(revision 99318adcb88fa3f1dd21882ec364e682fec96c5e)
@@ -43,5 +43,5 @@
 # PROP Target_Dir ""
 # ADD BASE CPP /nologo /MD /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_WINDOWS" /D "_AFXDLL" /Yu"stdafx.h" /FD /c
-# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I "..\protocols" /I ".." /I "deps\include" /I "deps\include\glib-2.0" /I "deps\lib\glib-2.0\include" /D "NDEBUG" /D "WIN32" /D "_WINDOWS" /D "_AFXDLL" /D "GLIB2" /FD /c
+# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I "..\protocols" /I ".." /I "deps\include" /I "deps\include\glib-2.0" /I "deps\lib\glib-2.0\include" /D "NDEBUG" /D "WIN32" /D "_WINDOWS" /D "_AFXDLL" /FD /c
 # SUBTRACT CPP /YX
 # ADD BASE MTL /nologo /D "NDEBUG" /mktyplib203 /o NUL /win32
@@ -54,5 +54,5 @@
 LINK32=link.exe
 # ADD BASE LINK32 /nologo /subsystem:windows /machine:I386
-# ADD LINK32 kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib iconv.lib glib-2.0.lib gmodule-2.0.lib /nologo /subsystem:windows /machine:I386 /libpath:"release" /libpath:"deps\lib"
+# ADD LINK32 kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib iconv.lib glib-2.0.lib gmodule-2.0.lib wsock32.lib advapi32.lib /nologo /subsystem:windows /machine:I386 /libpath:"release" /libpath:"deps\lib"
 # SUBTRACT LINK32 /incremental:yes /nodefaultlib
 
@@ -71,5 +71,5 @@
 # PROP Target_Dir ""
 # ADD BASE CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /D "WIN32" /D "_DEBUG" /D "_WINDOWS" /D "_AFXDLL" /Yu"stdafx.h" /FD /c
-# ADD CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /I "." /I "..\protocols" /I ".." /I "deps\include" /I "deps\include\glib-2.0" /I "deps\lib\glib-2.0\include" /D "_DEBUG" /D "WIN32" /D "_WINDOWS" /D "_AFXDLL" /D "GLIB2" /FR /FD /c
+# ADD CPP /nologo /Gd /MDd /Ze /W3 /Gm /GX /Zi /Od /I "." /I "..\protocols" /I ".." /I "deps\include" /I "deps\include\glib-2.0" /I "deps\lib\glib-2.0\include" /D "_DEBUG" /D "WIN32" /D "_WINDOWS" /D "_AFXDLL" /FR /FD /c
 # SUBTRACT CPP /YX
 # ADD BASE MTL /nologo /D "_DEBUG" /mktyplib203 /o NUL /win32
@@ -82,5 +82,5 @@
 LINK32=link.exe
 # ADD BASE LINK32 /nologo /subsystem:windows /debug /machine:I386 /pdbtype:sept
-# ADD LINK32 iconv.lib glib-2.0.lib gmodule-2.0.lib /nologo /subsystem:windows /debug /machine:I386 /pdbtype:sept /libpath:"debug" /libpath:"deps\lib"
+# ADD LINK32 iconv.lib glib-2.0.lib gmodule-2.0.lib wsock32.lib kernel32.lib user32.lib advapi32.lib /nologo /subsystem:windows /debug /machine:I386 /pdbtype:sept /libpath:"debug" /libpath:"deps\lib"
 
 !ENDIF 
@@ -104,8 +104,11 @@
 
 SOURCE=.\bitlbee.rc
-# End Source File
-# Begin Source File
-
-SOURCE=.\bitlbeewin.cpp
+
+!IF  "$(CFG)" == "bitlbee - Win32 Release"
+
+!ELSEIF  "$(CFG)" == "bitlbee - Win32 Debug"
+
+!ENDIF 
+
 # End Source File
 # Begin Source File
@@ -131,8 +134,4 @@
 # Begin Source File
 
-SOURCE=.\MainDlg.cpp
-# End Source File
-# Begin Source File
-
 SOURCE=..\protocols\md5.c
 # End Source File
@@ -147,24 +146,4 @@
 # Begin Source File
 
-SOURCE=.\PropAccess.cpp
-# End Source File
-# Begin Source File
-
-SOURCE=.\PropConn.cpp
-# End Source File
-# Begin Source File
-
-SOURCE=.\PropLog.cpp
-# End Source File
-# Begin Source File
-
-SOURCE=.\PropPaths.cpp
-# End Source File
-# Begin Source File
-
-SOURCE=.\PropUsers.cpp
-# End Source File
-# Begin Source File
-
 SOURCE=..\protocols\proxy.c
 # End Source File
@@ -183,8 +162,4 @@
 # Begin Source File
 
-SOURCE=.\TrayNot.cpp
-# End Source File
-# Begin Source File
-
 SOURCE=..\user.c
 # End Source File
@@ -201,4 +176,8 @@
 !ENDIF 
 
+# End Source File
+# Begin Source File
+
+SOURCE=..\win32.c
 # End Source File
 # End Group
@@ -216,8 +195,4 @@
 # Begin Source File
 
-SOURCE=.\bitlbeewin.h
-# End Source File
-# Begin Source File
-
 SOURCE=..\commands.h
 # End Source File
@@ -252,8 +227,4 @@
 # Begin Source File
 
-SOURCE=.\MainDlg.h
-# End Source File
-# Begin Source File
-
 SOURCE=..\protocols\md5.h
 # End Source File
@@ -268,28 +239,4 @@
 # Begin Source File
 
-SOURCE=.\PropAccess.h
-# End Source File
-# Begin Source File
-
-SOURCE=.\PropConn.h
-# End Source File
-# Begin Source File
-
-SOURCE=.\PropLog.h
-# End Source File
-# Begin Source File
-
-SOURCE=.\PropPaths.h
-# End Source File
-# Begin Source File
-
-SOURCE=.\PropUsers.h
-# End Source File
-# Begin Source File
-
-SOURCE=.\Resource.h
-# End Source File
-# Begin Source File
-
 SOURCE=..\set.h
 # End Source File
@@ -301,8 +248,4 @@
 
 SOURCE=..\sock.h
-# End Source File
-# Begin Source File
-
-SOURCE=.\TrayNot.h
 # End Source File
 # Begin Source File
Index: win32/bitlbee.dsw
===================================================================
--- win32/bitlbee.dsw	(revision d1d677615e12d759b6cdf7ce23a493bc055ef37f)
+++ win32/bitlbee.dsw	(revision 99318adcb88fa3f1dd21882ec364e682fec96c5e)
@@ -4,5 +4,5 @@
 ###############################################################################
 
-Project: "bitlbee"=".\bitlbee.dsp" - Package Owner=<4>
+Project: "admin"=.\admin1\admin.dsp - Package Owner=<4>
 
 Package=<5>
@@ -16,5 +16,5 @@
 ###############################################################################
 
-Project: "bitlbee_ssl"=".\bitlbee_ssl\bitlbee_ssl.dsp" - Package Owner=<4>
+Project: "bitlbee"=.\bitlbee.dsp - Package Owner=<4>
 
 Package=<5>
@@ -28,5 +28,17 @@
 ###############################################################################
 
-Project: "jabber"=".\jabber.dsp" - Package Owner=<4>
+Project: "bitlbee_ssl"=.\bitlbee_ssl.dsp - Package Owner=<4>
+
+Package=<5>
+{{{
+}}}
+
+Package=<4>
+{{{
+}}}
+
+###############################################################################
+
+Project: "jabber"=.\jabber.dsp - Package Owner=<4>
 
 Package=<5>
@@ -46,5 +58,5 @@
 ###############################################################################
 
-Project: "msn"=".\msn.dsp" - Package Owner=<4>
+Project: "msn"=.\msn.dsp - Package Owner=<4>
 
 Package=<5>
@@ -64,5 +76,5 @@
 ###############################################################################
 
-Project: "oscar"=".\oscar.dsp" - Package Owner=<4>
+Project: "oscar"=.\oscar.dsp - Package Owner=<4>
 
 Package=<5>
@@ -79,5 +91,5 @@
 ###############################################################################
 
-Project: "yahoo"=".\yahoo.dsp" - Package Owner=<4>
+Project: "yahoo"=.\yahoo.dsp - Package Owner=<4>
 
 Package=<5>
Index: win32/configure.mingw32
===================================================================
--- win32/configure.mingw32	(revision d1d677615e12d759b6cdf7ce23a493bc055ef37f)
+++ 	(revision )
@@ -1,37 +1,0 @@
-#!/bin/sh
-DEPSDIR=$1
-export PKG_CONFIG_LIBDIR=$DEPSDIR/lib/pkgconfig
-export PKG_CONFIG_OPTS=--define-variable=prefix=$DEPSDIR
-export PKG_CONFIG="pkg-config $PKG_CONFIG_OPTS"
-
-cat<<EOF>config.h
-/* BitlBee settings, generated by $0
-   
-   Do *NOT* use any of these defines in your code without thinking twice, most
-   of them can/will be overridden at run-time */
-#define CPU "i386"
-#define IPV6
-#define GLIB2
-#define ARCH "Windows"
-EOF
-
-cat<<EOF>Makefile.settings
-## BitlBee settings, generated by $0
-PREFIX=
-BINDIR=\$(PREFIX)/sbin/
-ETCDIR=\$(PREFIX)/etc/bitlbee/
-MANDIR=\$(PREFIX)/share/man/
-DATADIR=\$(PREFIX)/share/bitlbee/
-CONFIG=\$(PREFIX)/lib/bitlbee/
-ARCH=Windows
-CPU=i386
-OUTFILE=bitlbee.exe
-STRIP=i586-mingw32msvc-strip 
-
-DESTDIR=
-LFLAGS=`$PKG_CONFIG --libs glib-2.0` -L$DEPSDIR/lib -lws2_32 -liconv
-CFLAGS=`$PKG_CONFIG --cflags glib-2.0` -I$DEPSDIR/include -I`pwd` -I`pwd`/protocols
-CC=i586-mingw32msvc-gcc
-CXX=i586-mingw32msvc-g++
-LD=i586-mingw32msvc-ld
-EOF